//window.addEventListener('load',init,false);

var canvas=null;
var ctx=null;
var x=0;
var y=0;
var numRectsX = 10;
var numRectsY = 14;
var rectWidth = null;
var rectHeight = null;
var posActual = 0;
var moveLeft = false;
var numFillRectsIni = 4;
var numFillRectsActual = 0;
var lastPress = 0;
var actualRow = 1;
var gameLevel = 1;
var gameRefreshTime;
var gameStatusMatrix = null;
var gameRefreshInterval = null;
var gameScore = 0;


function init(){
	initVariables();
	numFillRectsActual = numFillRectsIni;
    canvas=document.getElementById('canvas');
	$("#gameScore").text("Score : ");
	if(canvas == null) return;
	rectWidth = canvas.width/numRectsX;
	rectHeight = canvas.height/numRectsY;
    ctx=canvas.getContext('2d');
	enableInput();
	initStatusMatrix();
	gameRefreshInterval = setInterval(function(){requestAnimationFrame(run);},gameRefreshTime);
}

function initVariables(){
	 canvas=null;
	 ctx=null;
	 x=0;
	 y=0;
	 numRectsX = 10;
	 numRectsY = 14;
	 rectWidth = null;
	 rectHeight = null;
	 posActual = 0;
	 moveLeft = false;
	 numFillRectsIni = 4;
	 numFillRectsActual = 0;
	 lastPress = 0;
	 actualRow = 1;
	 gameLevel = 1;
	 gameRefreshTime = 130;
	 gameScore = 0;
	 gameStatusMatrix = null;
	 clearInterval(gameRefreshInterval);
	 $("#gameLevel").text("Level "+gameLevel);
}

function initStatusMatrix (){
	gameStatusMatrix = new Array();
	
	for(var i=0;i<numRectsX;i++){
		gameStatusMatrix[i] = new Array();
		for(var j=0;j<numRectsY;j++){
			gameStatusMatrix[i][j] = new Figure();
		}
	}
}

function enableInput(){
	if(canvas == null ) return;
	
	disableInputs();
	$("#canvas").bind('touchstart',function(e){
		$("#canvas").unbind('mousedown');
		mouseDownEvent();
	});
	
	$("#canvas").bind('mousedown',function(e){
		mouseDownEvent();
	});
}

function disableInputs(){
	$("#canvas").unbind('touchstart');
	$("#canvas").unbind('mousedown');
}

function mouseDownEvent(){
	checkGameStatus(numFillRectsActual);
	saveFillRectsToPaint(numFillRectsActual);
	run();
	return false;

}

function saveFillRectsToPaint(numFillRects){
	var firstFillRectX = getFirstFilRectPosX();
	var j = getFirstFilRectPosY();
	
	for(var i=firstFillRectX;i<firstFillRectX+numFillRects;i++){
		gameStatusMatrix[i][j].setDrawable(true);
	}
	actualRow++;
}

function getFirstFilRectPosX(){
	return (posActual/rectWidth);
}

function getFirstFilRectPosY(){
	return (actualRow - 1);
}

function run(){	
	checkMove(numFillRectsActual);
	paint(ctx,numFillRectsActual,posActual);
	refreshReset();
}

function checkGameStatus(numFillRects){
	var firstFillRectX = getFirstFilRectPosX();
	var j = getFirstFilRectPosY();
	var alignedFound = false;
	
	if(j > 0){
		for(var i=firstFillRectX;i<firstFillRectX+numFillRects;i++){
			if(!gameStatusMatrix[i][j-1].isDrawable()){
				numFillRectsActual--;
				if(!alignedFound)
					posActual += rectWidth;
				continue;
			}
			alignedFound = true;
		}
	}
	setScore();
	checkGameOver();
	checkNextLevel();
}

function checkGameOver(){

	if(isGameOver()){
		addToBestScores();
		createLoseDialog();
	}	
}


function isGameOver(){

	if(numFillRectsActual == 0){
		return true;
	}	
	return false;
}

function createLoseDialog(){
	disableInputs();
	var dialog = document.getElementById("showOptions");
	dialog.innerHTML = "";
	dialog.style.visibility = "visible";
	
	
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "Game Over!";
	newDiv.style.textAlign = "center";
	newDiv.className = "showOptionsTitle";
	newDiv.style.marginBottom = "15%";
	newDiv.style.fontWeight = "Bold";
	dialog.appendChild(newDiv);
	
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "Your score is "+gameScore+" points";
	newDiv.style.textAlign = "center";
	newDiv.className = "showOptionsMessage";
	newDiv.style.marginBottom = "15%";
	newDiv.style.fontWeight = "Bold";
	dialog.appendChild(newDiv);
	
	setTimeout(function(){
		var newDiv = document.createElement("div");
		newDiv.innerHTML = "Retry";
		newDiv.style.margin = "0 auto";
		newDiv.style.marginBottom = "5%";
		newDiv.className = "showOptionsOption";
		newDiv.style.padding = "3%";
		newDiv.backgroundColor = "yellow"
		newDiv.style.backgroundColor = "yellow";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "rgba(240,230,140,0.5)";
		newDiv.style.textAlign = "center";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			init();
		};
		
		dialog.appendChild(newDiv);

		var newDiv = document.createElement("div");
		newDiv.innerHTML = "Best Scores";
		newDiv.className = "showOptionsOption";
		newDiv.style.margin = "0 auto";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "yellow"
		newDiv.style.textAlign = "center";
		newDiv.style.marginBottom = "5%";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			window.location.href="bestScores.html";
		};
		
		
		dialog.appendChild(newDiv);
		var newDiv = document.createElement("div");
		newDiv.innerHTML = "Quit";
		newDiv.className = "showOptionsOption";
		newDiv.style.margin = "0 auto";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "yellow"
		newDiv.style.textAlign = "center";
		newDiv.style.marginBottom = "5%";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			window.location.href="../index.html";

		};
		
		dialog.appendChild(newDiv);
	},1000);
	
	$('.showOptionsOption').css('opacity', '0.99');
	setTimeout(function() {
        $('.showOptionsOption').css('opacity', '1');
    }, 5);
	
}

function sortNumber(a,b) {
    return a.score - b.score;
}

function getBestScores(){
	if(typeof localStorage["bestScores"] == "undefined"){
		var div = document.getElementById("resultScore");
		div.innerHTML = "No scores available.";
		return;
	}
	
	var storedScores = JSON.parse(localStorage["bestScores"]);
	for(var i=0;i<storedScores.length;i++){
		storedScores[i].score = parseInt(storedScores[i].score);
	}
	storedScores.sort(sortNumber);
	
	var cont = 0;
	for(var i=storedScores.length-1;i>=0;i--){
		if(cont >=10)break;
		
		var container = document.getElementById("resultScore");
		var div = document.createElement("div");
		div.className = "col-md-12 col-sm-12 col-xs-12";
		
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-6 col-sm-6 col-xs-6";
		newDiv.style.padding = "3%";
		newDiv.innerHTML = storedScores[i].score+" points";
		
		div.appendChild(newDiv);
		
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-6 col-sm-6 col-xs-6 ";
		newDiv.style.padding = "3%";
		newDiv.innerHTML = storedScores[i].date;
		
		div.appendChild(newDiv);
		container.appendChild(div);
		cont++;
	}
}

function clearBestScores(){
	if(typeof localStorage["bestScores"] == "undefined") return;

	var div = document.getElementById("resultScore");
	div.innerHTML = "No scores available.";
	localStorage.removeItem("bestScores");
	return;
	

}

function addToBestScores(){
	var bestScores;
	var actualDate = new Date();
	var day = actualDate.getDate();
	var month = actualDate.getMonth()+1;
	var year = actualDate.getFullYear();
	
	if(typeof localStorage["bestScores"] == "undefined"){
		bestScores = new Array();
	}
	else{
	    bestScores = JSON.parse(localStorage["bestScores"]);
	}	
	bestScores.push({score: gameScore, date :  day+"/"+month+"/"+year});
	localStorage["bestScores"] = JSON.stringify(bestScores);
}

function setScore(){

	
	gameScore = (gameLevel * numFillRectsActual) +  gameScore;
	$("#gameScore").text("Score : "+gameScore);
}

function checkNextLevel(){

	if(actualRow == numRectsY){
		actualRow = 1;
		initStatusMatrix ();
		gameLevel++;
		clearInterval(gameRefreshInterval);
		setGameRefreshTime();
		$("#gameLevel").text("Level "+gameLevel);
		gameRefreshInterval = setInterval(function(){requestAnimationFrame(run);},gameRefreshTime);
		if(numFillRectsActual < numFillRectsIni && !isGameOver())
			numFillRectsActual++;
	}
}

function setGameRefreshTime(){
	if(gameRefreshTime <= 55) {
		gameRefreshTime = 40;
		return;
	}
	gameRefreshTime -= 30;
}

function refreshReset(){
	x=0;
	y=0;
}

function checkMove(numFillRects){

	if(moveLeft){
		if(posActual < rectWidth){
		   moveLeft = false;
		   posActual += rectWidth;
		   return;
		}
		else{
			posActual -= rectWidth;
			return;
		}
	}
	else{
		if(posActual+(rectWidth*numFillRects) >= canvas.width){
			posActual -= rectWidth;
			moveLeft = true;
			return;
		}
	   posActual += rectWidth;
	}
}

function paint(ctx,numFillRects){

	ctx.beginPath();
	ctx.fillStyle = "#113D99";
	ctx.fillRect(0,0,canvas.width,canvas.height);
	
	while( y <= canvas.height && x <= canvas.width){	
		ctx.lineWidth   = 1;
		ctx.strokeStyle = "black";
		ctx.rect(x,y,rectWidth,rectHeight);
		
		x+=rectWidth;
		if(x>canvas.width){
			y+=rectHeight;
			x=0;
		}	
	}
	ctx.fillStyle = "rgb(232,12,34)";
	
	var posDrawRect= 0;
	for(var i=0;i<numFillRects;i++){
		ctx.fillRect(posActual+posDrawRect,canvas.height-(rectHeight*actualRow),rectWidth-1,rectHeight-1);
		posDrawRect += rectWidth;
	}	
	
	for(var i=0;i<numRectsX;i++){
		for(var j=0;j<numRectsY;j++){
			if(gameStatusMatrix[i][j].isDrawable()){
				ctx.fillRect(i*rectWidth,canvas.height-(rectHeight*(j+1)),rectWidth-1,rectHeight-1);
			}
		}
	}
	ctx.stroke();
}

function Figure(){
	this.drawable = false;
}

Figure.prototype.setDrawable = function(drawable) {
  this.drawable = drawable;
};

Figure.prototype.isDrawable = function() {
  return this.drawable;
};

window.requestAnimationFrame=(function(){
    return window.requestAnimationFrame || 
        window.webkitRequestAnimationFrame || 
        window.mozRequestAnimationFrame || 
        function(callback ){window.setTimeout(callback ,gameRefreshTime);};
})();