(function(window){

	function Figure(fixDef,shapeSize,image){
		
		if(image == null)
			this.view = new createjs.Bitmap("");
		else{
			this.view = new createjs.Bitmap(image);
		}
			
		this.scaleImage(shapeSize);
		
		this.fixDef = fixDef;
		this.bodyDef = null;
		
		this.view.body = null;
		this.view.onTick = tick;

	}
	
	Figure.prototype.addToStage = function(){
		if(this.bodyDef == null) return;
		
		this.view.body = world.CreateBody(this.bodyDef);
		this.view.body.CreateFixture(this.fixDef);
		stage.addChild(this.view);
	}
	
	Figure.prototype.getFixDef = function(){
		return this.fixDef;
	}
	
	Figure.prototype.setBodyDef = function(bodyDef){
		this.bodyDef = bodyDef;
	}
	
	Figure.prototype.setImage = function(image){
		this.view.image = image;
	}
	
	Figure.prototype.scaleImage = function(shapeSize){
	
		if(this.view == null) return;
		
		var imageWidth = this.view.image.width;
		var imageHeight = this.view.image.height;
		
		this.view.regX = imageWidth/2;
		this.view.regY = imageHeight/2;
		this.shapeSize = shapeSize;
		
		if(shapeSize != null){
			var scaleY = shapeSize.y*2/imageHeight;
			var scaleX = shapeSize.x*2/imageWidth;
			this.view.scaleY = scaleY;
			this.view.scaleX = scaleX;
		}	
	}

	function tick(e){
		if(this.body == null )return;
		this.x = this.body.GetPosition().x*SCALE;
		this.y = this.body.GetPosition().y*SCALE ;
		this.rotation = this.body.GetAngle() * (180/Math.PI);
	}
	window.Figure = Figure;
})(window);