var arrayShapesLevel;
var arrayBasicShapesLevel;
var actualLevel = 1;
var numLevels = 6;


function loadArrayShapeLevel(){

	arrayShapesLevel = new Array();
	for(var i=1;i<=numLevels;i++){
		arrayShapesLevel.push(window["getShapesLevel"+i]());
	}
}

function loadArrayBasicShapeLevel(){

	arrayBasicShapesLevel = new Array();
	for(var i=1;i<=numLevels;i++){
		arrayBasicShapesLevel.push(window["getBasicShapesLevel"+i]());
	}
}

function getArrayShapeLevel(){

	return arrayShapesLevel[actualLevel-1];
}

function getBasicArrayShapeLevel(){

	return arrayBasicShapesLevel[actualLevel-1];
}

function getPointsForGroundPosition(shapeSize, positionShape){

	var positionShapeAux = getMaxPointsForGroundPosition(shapeSize, positionShape);
	positionShapeAux = getMinPointsForGroundPosition(shapeSize, positionShape);
	
	return positionShapeAux;
}

function getMaxPointsForGroundPosition(shapeSize, positionShape){
	var maxPointsToPutBody = calculatePoints(limitShapeListPercent,100);
	 
	if(positionShape.x > maxPointsToPutBody.x-shapeSize.x)
		positionShape.x = maxPointsToPutBody.x - shapeSize.x;
	if(positionShape.y > maxPointsToPutBody.y-shapeSize.y)
		positionShape.y = maxPointsToPutBody.y - shapeSize.y;
		
	 return positionShape;
}

function getMinPointsForGroundPosition(shapeSize, positionShape){
	var minPointsToPutBody = calculatePoints(0,0);
	 
	if(positionShape.x < minPointsToPutBody.x+shapeSize.x)
		positionShape.x = minPointsToPutBody.x + shapeSize.x;
	if(positionShape.y < minPointsToPutBody.y+shapeSize.y)
		positionShape.y = minPointsToPutBody.y + shapeSize.y;
		
	 return positionShape;
}


/*-----------------------LEVEL 1 --------------------*/
function getBasicShapesLevel1(){

	var arrayBasicShapesLevel1 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;

	shapeSize = calculatePoints(10,5);
	positionShape = calculatePoints(40,99);
	positionShape = getPointsForGroundPosition(shapeSize,positionShape);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayBasicShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize, stagePos : positionShape});

	return arrayBasicShapesLevel1;

}

function getShapesLevel1(){

	var arrayShapesLevel1 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(12,5);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(5,5);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/blueCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(5,5);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);

	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(8.8,11.7);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel1.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize, points : {percentX:8.8, percentY : 11.7} } );
	
	return arrayShapesLevel1;

}


/*------------------------------- LEVEL 2 -------------------------------------------*/

function getBasicShapesLevel2(){

	var arrayBasicShapesLevel2 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;
	
	shapeSize = calculatePoints(7,15);
	positionShape = calculatePoints(60,85);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize, stagePos : positionShape});
	
	shapeSize = calculatePoints(7,8);
	positionShape = calculatePoints(25,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize, stagePos : positionShape});

	return arrayBasicShapesLevel2;

}

function getShapesLevel2(){

	var arrayShapesLevel2 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(7,8);
	positionShape = calculatePoints(35,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	shapeSize = calculatePoints(8,8);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);

	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/pink.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);
	
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	shapeSize = calculatePoints(3,5);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(9,5);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(3,2);
	var fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	

	return arrayShapesLevel2;

}

/*------------------------------- LEVEL 3 -------------------------------------------*/

function getBasicShapesLevel3(){

	var arrayBasicShapesLevel2 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;
	
	shapeSize = calculatePoints(4,4);
	positionShape = calculatePoints(40,95);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize, stagePos : positionShape});

	return arrayBasicShapesLevel2;

}

function getShapesLevel3(){

	var arrayShapesLevel2 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(10,8);
	positionShape = calculatePoints(35,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	shapeSize = calculatePoints(10,5);
	positionShape = calculatePoints(35,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
		  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	shapeSize = calculatePoints(8,8);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);

	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/pink.png"), size : shapeSize});
	

	return arrayShapesLevel2;

}

/*------------------------------- LEVEL 4 -------------------------------------------*/

function getBasicShapesLevel4(){

	var arrayBasicShapesLevel2 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
	positionShape = calculatePoints(15,75);	  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize, stagePos : positionShape});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
	positionShape = calculatePoints(35,35);	  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize, stagePos : positionShape});
	
	var shapeSize = calculatePoints(4,4);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
	positionShape = calculatePoints(55,75);	  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize, stagePos : positionShape});
	
	return arrayBasicShapesLevel2;

}

function getShapesLevel4(){

	var arrayShapesLevel2 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(10,8);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	shapeSize = calculatePoints(10,8);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(10,8);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(5,5);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);

	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/pink.png"), size : shapeSize});
	
	shapeSize = calculatePoints(10,8);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/blueCube.png"), size : shapeSize});

	return arrayShapesLevel2;

}


/*------------------------------- LEVEL 5 -------------------------------------------*/

function getBasicShapesLevel5(){

	var arrayBasicShapesLevel2 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;
	
	shapeSize = calculatePoints(0.5,10);
	positionShape = calculatePoints(35,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/orangeGradient.png"), size : shapeSize, stagePos : positionShape});
	
	return arrayBasicShapesLevel2;

}

function getShapesLevel5(){

	var arrayShapesLevel2 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(10,8);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/blueCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(0.5,11);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/orangeGradient.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(7,7);
	shapeSize.y = shapeSize.x;
	var fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});

	return arrayShapesLevel2;

}

/*------------------------------- LEVEL 5 -------------------------------------------*/

function getBasicShapesLevel6(){

	var arrayBasicShapesLevel2 = new Array();
	var shapeSize;
	var positionShape;
	var fixDef;
	
	/*shapeSize = calculatePoints(0.5,10);
	positionShape = calculatePoints(35,92);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);*/
	
	shapeSize = calculatePoints(3,3);
	shapeSize.y = shapeSize.x;
	positionShape = calculatePoints(15,62);
	var fixDef = createCircleShape(shapeSize.x);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize, stagePos : positionShape});
	
	var shapeSize = calculatePoints(7,7);
	var arrayTriangle = calculateArrayTrianglePoints(shapeSize);
	positionShape = calculatePoints(35,62);	  
	var fixDef = createTriangleShape(arrayTriangle);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize, stagePos : positionShape});
	
	shapeSize = calculatePoints(3,3);
	shapeSize.y = shapeSize.x;
	positionShape = calculatePoints(55,62);
	var fixDef = createCircleShape(shapeSize.x);
	arrayBasicShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize, stagePos : positionShape});
	
	return arrayBasicShapesLevel2;

}

function getShapesLevel6(){

	var arrayShapesLevel2 = new Array();
	var shapeSize;
	
	shapeSize = calculatePoints(2,12);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/orangeGradient.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,12);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/orangeGradient.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(7,7);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/pink.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/blueCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(7,3);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/gift.png"), size : shapeSize});
	
	shapeSize = calculatePoints(6,6);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/tesoro.png"), size : shapeSize});
	
	shapeSize = calculatePoints(11,11);
	arrayTriangle = calculateArrayTrianglePoints(shapeSize); 
	fixDef = createTriangleShape(arrayTriangle);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/triangle.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(2,2);
	shapeSize.y = shapeSize.x;
    fixDef = createCircleShape(shapeSize.x);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/soccer.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});
	
	shapeSize = calculatePoints(4,4);
	fixDef = createPolygonShape(shapeSize.x,shapeSize.y);
	arrayShapesLevel2.push({shape : new Figure(fixDef,shapeSize,"img/redCube.png"), size : shapeSize});

	return arrayShapesLevel2;

}

