var box2d = {
    b2Vec2 : Box2D.Common.Math.b2Vec2,
    b2BodyDef : Box2D.Dynamics.b2BodyDef,
    b2Body : Box2D.Dynamics.b2Body,
    b2FixtureDef : Box2D.Dynamics.b2FixtureDef,
    b2Fixture : Box2D.Dynamics.b2Fixture,
    b2World : Box2D.Dynamics.b2World,
    b2MassData : Box2D.Collision.Shapes.b2MassData,
    b2PolygonShape : Box2D.Collision.Shapes.b2PolygonShape,
    b2CircleShape : Box2D.Collision.Shapes.b2CircleShape,
    b2DebugDraw : Box2D.Dynamics.b2DebugDraw,
	b2Listener : Box2D.Dynamics.b2ContactListener
};
var canvas = document.getElementById('canvas');
var debug = document.getElementById('debug');
var SCALE = 30;
var stage, world;
var mousePos;
var ground;
var listener = new box2d.b2Listener;
var isGameOver = false;
var arrayShapes, arrayBasicShapes;
var posShapeToShow, posBasicShapeToShow;
var actualBody;
var mouseJoinedBody;
var bodySpeed = 100;
var listShapesToShow = new Array();
var limitShapeListPercent = 75;
var lastFigure;
var firstStep;
var lastBasicFigure;
var lastLimitFigure;
var limitLineSize = 5;
var listLimits = new Array();
var counter;
var countDown;
var isGameWined;
var limitSizePercent = 87.5;
var arrayLimitListShapesToShow = new Array();
var actualWidt;
var arrayBasicFiguresShapes = new Array();
var countLevelSeconds;
var levelSeconds;
	  
function init(){

	resetVariables();
	stage = new createjs.Stage(document.getElementById("canvas"));
	setupPhysics();
	stageOnUserClick();
	createjs.Ticker.addListener(this);
	createjs.Ticker.setFPS(60);
	createjs.Ticker.useRAF = false;
	world.SetContactListener(listener);
	
	loadBasicShapesLevel();
	loadListLimits();
	loadShapesLevel();
	repaintBasicShapes();
	showListShapesToStack();
	drawLimits();
	countActualLevelSeconds();

}

function repaintAll(){

	loadShapesLevel();
	loadBasicShapesLevel();
	repaintBasicShapes();
	showListShapesToStack();
	drawLimits();
	//cleanDynamicShapesInWorld();
	actualWidht = canvas.clientWidth;
	
	canvas.width = canvas.clientWidth;
	canvas.height = canvas.clientHeight;
	
	debug.width = canvas.clientWidth;
	debug.height = canvas.clientHeight;
	
}

function resetVariables(){
	counter = 0;
	actualWidht = canvas.clientWidth;
	posShapeToShow = 0;
	firstStep = true;
	isGameOver = false;
	isGameWined = false;
	actualLevel = getActualLevelLocalStorage();
	
	canvas.width = canvas.clientWidth;
	canvas.height = canvas.clientHeight;
	
	debug.width = canvas.clientWidth;
	debug.height = canvas.clientHeight;
	
	clearInterval(countDown);
	clearInterval(countLevelSeconds);
}

function calculateLimitLineSize(){
	var size = calculatePoints(limitLineSize,0);
	limitLineSize = size.x;
}

function resetActualLevel(){

	if(typeof localStorage["maxLevelReached"] == "undefined"){
		localStorage["maxLevelReached"] = actualLevel;
		return actualLevel;
	}
	
	return localStorage["maxLevelReached"];

}


function stageOnUserClick(){
	debug.onmousedown = function(){
		checkStatusOnUserClick();
	}
	
}

function checkStatusOnUserClick(){
	if(isGameOver) return;
	if(arrayShapes[posShapeToShow] == null || arrayShapes == null)return;
	var limitPoints = calculatePoints(limitShapeListPercent,0);
	if(mousePos.x > limitPoints.x) return;
	if(actualBody != null)
		actualBody.SetUserData("");
	if(lastFigure != null){
		stage.removeChild(lastFigure.view);
		if(lastFigure.view.body != null)
			world.DestroyBody(lastFigure.view.body);			
	}
	addNextShapeToWorld(mousePos.x,mousePos.y,"");
	posShapeToShow++;
	showListShapesToStack();
	if(isAllShapesStack()){
		countDownFunction();
	}
}

function forceUpdateCanvas(){
	$('canvas').css('opacity', '0.99');
	setTimeout(function() {
        $('canvas').css('opacity', '1');
    }, 5);
}


function countDownFunction(){
	counter = 4;
	var result = document.getElementById("countDown");
	result.style.visibility =  "visible";
	result.innerHTML =  "Hold "+counter.toString()+" seconds!";
	clearInterval(countLevelSeconds);
	
	countDown = setInterval(function() {
			if(isGameOver) {
				result.style.visibility =  "hidden";
				clearInterval(countDown);
				return;
			}
			counter--;
			if(counter <= 0) {
				gameWin();
			} else {
				result = document.getElementById("countDown");
				result.innerHTML =  "Hold "+counter.toString()+" seconds!";
			}
		}, 1000);
}

function gameWin(){

	setBestLevelTimeLocalStorage();
	clearCountDownContainer();
	createWinDialog();
	if(actualLevel < numLevels)
		actualLevel++;
	setActualLevelLocalStorage(actualLevel);
	setMaxLevelLocalStorage();
	isGameWined = true;
}

function countActualLevelSeconds(){

	var result = document.getElementById("result");
	result.style.visibility =  "visible";
	levelSeconds = 0;
	result.innerHTML =  levelSeconds.toString();
	
	countLevelSeconds = setInterval(function() {
			levelSeconds++;
			result.innerHTML =  levelSeconds.toString();

		}, 1000);

}

function clearCountDownContainer(){
	var result = document.getElementById("countDown");
	result.style.visibility =  "hidden";
	clearInterval(countDown);
}

function setActualLevelLocalStorage(level){

	if(typeof localStorage["actualLevel"] == "undefined"){
		localStorage["actualLevel"] = level;
		return;
	}
	localStorage["actualLevel"] = level;
	
}

function getActualLevelLocalStorage(){
	if(actualLevel == null){
		actualLevel = 1;
	}
	if(typeof localStorage["actualLevel"] == "undefined"){
		localStorage["actualLevel"] = actualLevel;
		return actualLevel;
	}
	return localStorage["actualLevel"];
	
}

function setMaxLevelLocalStorage(){
	if(actualLevel == null){
		actualLevel = 1;
	}
	if(typeof localStorage["maxLevelReached"] == "undefined"){
		localStorage["maxLevelReached"] = actualLevel;
		return;
	}
	
	var maxLevelReached = localStorage["maxLevelReached"];
	if(maxLevelReached < actualLevel)
		localStorage["maxLevelReached"] = actualLevel;

}

function clearBestTimes(){
	if(typeof localStorage["bestTimes"] == "undefined") return;

	var div = document.getElementById("results");
	div.innerHTML ="";
	
	var newDiv = document.createElement("div");
	newDiv.className = "col-md-12 col-sm-12 col-xs-12 resultScore";
	newDiv.innerHTML = "No times Available.";
	div.appendChild(newDiv);
	localStorage.removeItem("bestTimes");
	
}

function setBestLevelTimeLocalStorage(){
	var bestTime;
	var actualDate = new Date();
	var day = actualDate.getDate();
	var month = actualDate.getMonth()+1;
	var year = actualDate.getFullYear();
				
	
	if(typeof localStorage["bestTimes"] == "undefined"){
		bestTime = new Array();
	}
	else{
	    bestTime = JSON.parse(localStorage["bestTimes"]);
	}	
	
	for(var i=0;i<bestTime.length;i++){
		if(actualLevel == bestTime[i].level){
			if(levelSeconds < bestTime[i].seconds){
				 bestTime[i].seconds = levelSeconds;
				  bestTime[i].dateStore = day+"/"+month+"/"+year;
				 localStorage["bestTimes"] = JSON.stringify(bestTime); 
			}
			return;
		}
	}
	bestTime.push({level : actualLevel, seconds : levelSeconds, dateStore : day+"/"+month+"/"+year});
	localStorage["bestTimes"] = JSON.stringify(bestTime);

}

function getBestLevelTimeLocalStorage(level){
	var bestTime;
	
	if(typeof localStorage["bestTimes"] == "undefined"){
		bestTime = new Array();
	}
	else{
	    bestTime = JSON.parse(localStorage["bestTimes"]);
	}	
	for(var i=0;i<bestTime.length;i++){
		if(level == bestTime[i].level){
			return bestTime[i].seconds;
		}
	}
	return 0;

}

function sortLevel(a,b) {
    return b.level - a.level;
}

function showBestTimes(){
	
	if(typeof localStorage["bestTimes"] == "undefined"){
		var div = document.getElementById("results");
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-12 col-sm-12 col-xs-12 resultScore";
		newDiv.innerHTML = "No times Available.";
		div.appendChild(newDiv);
		return;
	}
	
	var storedScores = JSON.parse(localStorage["bestTimes"]);
	for(var i=0;i<storedScores.length;i++){
		storedScores[i].level = parseInt(storedScores[i].level);
	}
	storedScores.sort(sortLevel);
	
	for(var i=storedScores.length-1;i>=0;i--){
		var container = document.getElementById("results");
		
		var div = document.createElement("div");
		div.className = "col-md-12 col-sm-12 col-xs-12 resultScore";
		
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-4 col-sm-4 col-xs-4 ";
		newDiv.style.padding = "3%";
		newDiv.innerHTML = "Level "+storedScores[i].level;
		
		div.appendChild(newDiv);
		
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-4 col-sm-4 col-xs-4 ";
		newDiv.style.padding = "3%";
		newDiv.innerHTML = storedScores[i].seconds+" seconds";
		
		div.appendChild(newDiv);
		
		var newDiv = document.createElement("div");
		newDiv.className = "col-md-4 col-sm-4 col-xs-4 ";
		newDiv.style.padding = "3%";
		newDiv.innerHTML = storedScores[i].dateStore;
		
		div.appendChild(newDiv);
		
		container.appendChild(div);
	}
}


function getMaxLevelLocalStorage(){
	if(actualLevel == null){
		actualLevel = 1;
	}
	if(typeof localStorage["maxLevelReached"] == "undefined"){
		localStorage["maxLevelReached"] = actualLevel;
		return actualLevel;
	}
	
	return localStorage["maxLevelReached"];
}


function setSelectLevelsItem(){
	var maxLevelReached = getMaxLevelLocalStorage();
	
	for(var i=1;i<=numLevels;i++){
		var dialog = document.getElementById("levelsItems");
		var newDiv = document.createElement("div");
		newDiv.innerHTML = i;
		newDiv.style.textAlign = "center";
		newDiv.className = "showOptionsTitle col-md-3 col-md-offset-1 col-sm-3 col-sm-offset-1 col-xs-5 col-xs-offset-1";
		if(i<=maxLevelReached){
			newDiv.className += " divItemLinkAvailable";
			newDiv.level = i;
			newDiv.onclick = function(){		
				goToGame(this.level);
			};
		}
		else{
			newDiv.className += " divItemLinkNotAvailable";
		}
		newDiv.style.marginBottom = "5%";
		newDiv.style.fontWeight = "Bold";
		
		dialog.appendChild(newDiv);
	}
}

function goToGame(level){
	setActualLevelLocalStorage(level);
	window.location.href="game.html";
}

function createWinDialog(){

	var dialog = document.getElementById("showOptions");
	dialog.innerHTML = "";
	dialog.style.visibility = "visible";
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "You Win!";
	newDiv.style.textAlign = "center";
	newDiv.className = "showOptionsTitle";
	newDiv.style.marginBottom = "15%";
	newDiv.style.fontWeight = "Bold";
	dialog.appendChild(newDiv);
	
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "Finished in "+levelSeconds+" seconds";
	newDiv.style.textAlign = "center";
	newDiv.className = "showOptionsMessage";
	newDiv.style.marginBottom = "15%";
	newDiv.style.fontWeight = "Bold";
	dialog.appendChild(newDiv);
	
	if(actualLevel < numLevels){
		var newDiv = document.createElement("div");
		newDiv.innerHTML = "Next Level";
		newDiv.style.margin = "0 auto";
		newDiv.style.marginBottom = "5%";
		newDiv.className = "showOptionsOption";
		newDiv.style.padding = "3%";
		newDiv.backgroundColor = "yellow"
		newDiv.style.backgroundColor = "yellow";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "rgba(240,230,140,0.5)";
		newDiv.style.textAlign = "center";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			init();
		};
		dialog.appendChild(newDiv);
	}
	
	var newDiv = document.createElement("div");
		newDiv.innerHTML = "Quit";
		newDiv.className = "showOptionsOption";
		newDiv.style.margin = "0 auto";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "yellow"
		newDiv.style.textAlign = "center";
		newDiv.style.marginBottom = "5%";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			window.location.href = "../index.html"
		};
	
	
	dialog.appendChild(newDiv);
}

function createLoseDialog(){

	var dialog = document.getElementById("showOptions");
	dialog.innerHTML = "";
	dialog.style.visibility = "visible";
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "You Lose!";
	newDiv.style.textAlign = "center";
	newDiv.className = "showOptionsTitle";
	newDiv.style.marginBottom = "15%";
	newDiv.style.fontWeight = "Bold";
	dialog.appendChild(newDiv);
	
	var newDiv = document.createElement("div");
	newDiv.innerHTML = "Retry";
	newDiv.style.margin = "0 auto";
	newDiv.style.marginBottom = "5%";
	newDiv.className = "showOptionsOption";
	newDiv.style.padding = "3%";
	newDiv.backgroundColor = "yellow"
	newDiv.style.backgroundColor = "yellow";
	newDiv.style.borderRadius = "24px";
	newDiv.style.backgroundColor = "rgba(240,230,140,0.5)";
	newDiv.style.textAlign = "center";
	newDiv.onclick = function(){
		dialog.style.visibility = "hidden";
		setActualLevelLocalStorage(actualLevel);
		init();
	};
	
	dialog.appendChild(newDiv);

	
	var newDiv = document.createElement("div");
		newDiv.innerHTML = "Quit";
		newDiv.className = "showOptionsOption";
		newDiv.style.margin = "0 auto";
		newDiv.style.borderRadius = "24px";
		newDiv.style.backgroundColor = "yellow"
		newDiv.style.textAlign = "center";
		newDiv.style.marginBottom = "5%";
		newDiv.onclick = function(){
			dialog.style.visibility = "hidden";
			window.location.href = "../index.html"
		};

	dialog.appendChild(newDiv);
}

function showListShapesToStack(){

	var y = 10;

	cleanListShapesToShow();
	cleanLimitsListShapesToShow();
	
	for(var i=posShapeToShow;i<arrayShapes.length;i++){
		if(i==posShapeToShow){
			y = (arrayShapes[i].size.y*100/canvas.clientHeight)+4;
		}
		var points = calculatePoints(limitSizePercent, y);
		var bodyDef = createStaticBodyDef(points.x,points.y,"");
		var image = arrayShapes[i].shape.view.image.src;
		var shapeSize = arrayShapes[i].size;

		var fixDef = arrayShapes[i].shape.getFixDef();
		var figure = new Figure(fixDef,shapeSize,image);
		
		var limitPoints = points;
		limitPoints.y += arrayShapes[i].size.y+5;
		
		addLimitListShapesToShow(limitPoints);
		
		figure.setBodyDef(bodyDef);
		figure.addToStage();
		listShapesToShow.push(figure);
		if(arrayShapes[i+1] != null)
			y +=(arrayShapes[i].size.y*100/canvas.clientHeight)+((arrayShapes[i+1].size.y)*100/canvas.clientHeight)+8;
	}
	
	drawLimitsListShapesToShow();
}

function addLimitListShapesToShow(points){
	var shapeSize = calculatePoints(100-limitSizePercent,0);
	arrayLimitListShapesToShow.push(drawStaticFigureBody(shapeSize.x-limitLineSize,limitLineSize, points.x , points.y,"ground"));
}

function drawLimitsListShapesToShow(){
	for(var i=0;i<arrayLimitListShapesToShow.length;i++){
		var limit = arrayLimitListShapesToShow[i];
		limit.addToStage();	
	}

}

function cleanLimitsListShapesToShow(){

	for(var i=0;i<arrayLimitListShapesToShow.length;i++){
		var limit = arrayLimitListShapesToShow[i];
		world.DestroyBody(limit.view.body);
		stage.removeChild(limit.view);
	}
	arrayLimitListShapesToShow = new Array();
}

function isAllShapesStack(){
	if(posShapeToShow >= arrayShapes.length){
		return true;
	}
	return false;
}

function cleanListShapesToShow(){

	for(var i=0;i<listShapesToShow.length;i++){
		stage.removeChild(listShapesToShow[i].view)
		world.DestroyBody(listShapesToShow[i].view.body);
	}
	listShapesToShow = new Array();
}

var arrayDynamicShapesInWorld = new Array();

function addNextShapeToWorld(posX,posY,userData){
	
	var fixDef = arrayShapes[posShapeToShow].shape.getFixDef();
	var image = arrayShapes[posShapeToShow].shape.view.image.src;
	var shapeSize = arrayShapes[posShapeToShow].size;
	var bodyDef = createDynamicBodyDef(posX,posY,userData); 
	fixDef.filter.maskBits = 65535;
	var figure = new Figure(fixDef,shapeSize,image);
	
	figure.setBodyDef(bodyDef);
	figure.addToStage();
	
	arrayDynamicShapesInWorld.push(figure);
}

function cleanDynamicShapesInWorld(){
	
	for(var i=0;i<arrayDynamicShapesInWorld.length;i++){
		stage.removeChild(arrayDynamicShapesInWorld[i].view)
		world.DestroyBody(arrayDynamicShapesInWorld[i].view.body);
	}
	redrawDynamicShapesInWorld();
}

function redrawDynamicShapesInWorld(){
	
	for(var i=0;i<arrayDynamicShapesInWorld.length;i++){
	
		var figure = arrayDynamicShapesInWorld[i];
		figure.addToStage();
	}
	
}

function repaintBasicShapes(){

	cleanBasicShapes();
	for(var i=0;i<arrayBasicShapes.length;i++){
		var positionShape = arrayBasicShapes[i].stagePos;
		arrayBasicFiguresShapes.push(addStaticShapeToWorld(i,positionShape,"basic"));
	}

}

function cleanBasicShapes(){

	for(var i=0;i<arrayBasicFiguresShapes.length;i++){
		stage.removeChild(arrayBasicFiguresShapes[i].view)
		world.DestroyBody(arrayBasicFiguresShapes[i].view.body);
	}
	arrayBasicFiguresShapes = new Array();
}

function repaintActualShape(posX,posY,userData){
		
	if(arrayShapes[posShapeToShow] != null){
		var fixDef = arrayShapes[posShapeToShow].shape.fixDef;
		var image = arrayShapes[posShapeToShow].shape.view.image.src;
		var bodyDef = createStaticBodyDef(mousePos.x,mousePos.y,"moveItem"); 
		var size = arrayShapes[posShapeToShow].size;
		fixDef.filter.maskBits = 2;
		
		if(lastFigure != null){
			stage.removeChild(lastFigure.view);
			if(lastFigure.view.body != null)
				world.DestroyBody(lastFigure.view.body);			
		}
		if(mousePos != null ){
			lastFigure = new Figure(fixDef,size,image);	
			lastFigure.setBodyDef(bodyDef);
			lastFigure.addToStage();
		}
		if(lastFigure.bodyDef != null){
			mouseJoinedBody = world.CreateBody(lastFigure.bodyDef);
			mouseJoinedBody.CreateFixture(lastFigure.fixDef);	
		}
	}
	
	if(lastFigure != null && arrayShapes[posShapeToShow] == null){
		if(lastFigure.view.getStage() == null ) return;
		stage.removeChild(lastFigure.view);
		world.DestroyBody(lastFigure.view.body);
	}
}


function addStaticShapeToWorld(posFigure, positionShape,userData){
	
	var fixDef = arrayBasicShapes[posFigure].shape.getFixDef();
	var image = arrayBasicShapes[posFigure].shape.view.image.src;
	var shapeSize = arrayBasicShapes[posFigure].size;
	var bodyDef = createStaticBodyDef(positionShape.x,positionShape.y,userData); 
	var figure = new Figure(fixDef,shapeSize,image);
	
	lastBasicFigure = figure.setBodyDef(bodyDef);
	figure.addToStage();
	
	return figure;
}

function loadBasicShapesLevel(){
	loadArrayBasicShapeLevel();
	posBasicShapeToShow = 0;
	arrayBasicShapes = getBasicArrayShapeLevel();
}

function loadShapesLevel(){
	loadArrayShapeLevel();
	arrayShapes = getArrayShapeLevel();
}

function createPolygonShape(width,height){

	var fixDef= new box2d.b2FixtureDef();
	fixDef.density = 1;
	fixDef.friction = 10;
	fixDef.restitution = 0.5;
	fixDef.shape = new box2d.b2PolygonShape();
	fixDef.shape.SetAsBox(width/SCALE, height/SCALE);	
	
	return fixDef;
}

function createCircleShape(radius){

	var fixDef= new box2d.b2FixtureDef();
	fixDef.density = 1;
	fixDef.friction = 10;
	fixDef.restitution = 0.5;
	fixDef.shape = new box2d.b2CircleShape(radius/SCALE);
	
	return fixDef;
	
}

function createTriangleShape(arrayTriangle){

	var fixDef= new box2d.b2FixtureDef();
	fixDef.density = 1;
	fixDef.friction = 10;
	fixDef.restitution = 0.5;
	fixDef.shape = new box2d.b2PolygonShape();
	fixDef.shape.SetAsArray(arrayTriangle);
	
	return fixDef;
}

function calculateArrayTrianglePoints(shapeSize){

	var arrayTriangle = new Array();
	
	arrayTriangle.push(new box2d.b2Vec2(0 , -shapeSize.y/SCALE));
	arrayTriangle.push(new box2d.b2Vec2(shapeSize.x/SCALE, shapeSize.y/SCALE));
	arrayTriangle.push(new box2d.b2Vec2(-shapeSize.x/SCALE, shapeSize.y/SCALE));
	
	return arrayTriangle;
	
}

function createDynamicBodyDef(posX,posY,userData){

	var bodyDef = new box2d.b2BodyDef();
	bodyDef.type = box2d.b2Body.b2_dynamicBody;
	bodyDef.position.x = posX / SCALE;
	bodyDef.position.y = posY / SCALE;
	bodyDef.userData = userData;
	
	return bodyDef;
}

function createStaticBodyDef(posX,posY,userData){

	var bodyDef = new box2d.b2BodyDef();
	bodyDef.type = box2d.b2Body.b2_staticBody;
	bodyDef.position.x = posX / SCALE;
	bodyDef.position.y = posY / SCALE;
	bodyDef.userData = userData;
	
	return bodyDef;
}

function createKinematicBodyDef(posX,posY,userData){

	var bodyDef = new box2d.b2BodyDef();
	bodyDef.type = box2d.b2Body.b2_kinematicBody;
	bodyDef.linearVelocity.x = 1;
	bodyDef.linearVelocity.y = 0;
	bodyDef.position.x = posX / SCALE;
	bodyDef.position.y = posY / SCALE;
	bodyDef.userData = userData;
	
	return bodyDef;
}

function getMousePos(canvas, evt) {
	var rect = canvas.getBoundingClientRect();
	return {
	  x: evt.clientX - rect.left,
	  y: evt.clientY - rect.top
	};
}

function calculatePoints(percentX,percentY){

	var width =  canvas.clientWidth;
	var height  = canvas.clientHeight;

	return {
	  x: (width*percentX)/100,
	  y: (height*percentY)/100
	};
}


function loadListLimits(){
	listLimits = new Array();
	
	var points = calculatePoints(limitShapeListPercent,0);
	listLimits.push(drawStaticFigureBody(limitLineSize,canvas.clientHeight,points.x, 0,"limit"));
	listLimits.push(drawStaticFigureBody(canvas.clientWidth,limitLineSize, 0 , canvas.clientHeight,"ground"));
	listLimits.push(drawStaticFigureBody(canvas.clientWidth,limitLineSize, 0 , 0, "limit"));
	listLimits.push(drawStaticFigureBody(limitLineSize,canvas.clientHeight, canvas.clientWidth , 0,"limit"));
	listLimits.push(drawStaticFigureBody(limitLineSize,canvas.clientHeight,0, canvas.clientHeight,"limit"));

}

function cleanLimits(){

	for(var i=0; i<listLimits.length;i++){
		if(listLimits[i].view.body == null) return;
		stage.removeChild(listLimits[i].view);
		world.DestroyBody(listLimits[i].view.body);
	}
	
}

function drawLimits(){

	cleanLimits();
	loadListLimits();
	for(var i=0; i<listLimits.length;i++){
		var figure = listLimits[i];
		figure.addToStage();
	}
	
}

function setupPhysics(){

	world = new box2d.b2World(new box2d.b2Vec2(0,30),true);
	var debugDraw = new box2d.b2DebugDraw();
	debugDraw.SetSprite(debug.getContext('2d'));
	debugDraw.SetDrawScale(SCALE);
	debugDraw.SetFillAlpha(0.7);
	//debugDraw.SetFlags(box2d.b2DebugDraw.e_shapeBit | box2d.b2DebugDraw.e_joinBit);
	world.SetDebugDraw(debugDraw);
}

function drawStaticBody(width,height, x, y,userdata){

	var fixDef= createPolygonShape(width,height);
	
	ground = new box2d.b2BodyDef();
	ground.type = box2d.b2Body.b2_staticBody;
	ground.position.x = x / SCALE;
	ground.position.y = y / SCALE;
	ground.userData = userdata;
	
	world.CreateBody(ground).CreateFixture(fixDef);
}

function drawStaticFigureBody(width,height, x, y,userdata){

	var fixDef= createPolygonShape(width,height);
	
	ground = new box2d.b2BodyDef();
	ground.type = box2d.b2Body.b2_staticBody;
	ground.position.x = x / SCALE;
	ground.position.y = y / SCALE;
	ground.userData = userdata;
	
	if(lastLimitFigure != null){
		stage.removeChild(lastLimitFigure.view);
		if(lastLimitFigure.view.body != null)
			world.DestroyBody(lastLimitFigure.view.body);
	}
	if(width>height){
		var shapeSize = calculatePoints(0,0);
		shapeSize.x = width;
		shapeSize.y = limitLineSize;
	}
	else{
		var shapeSize = calculatePoints(0,0);
		shapeSize.x = limitLineSize;
		shapeSize.y = height;
	}
		
	var figure = new Figure(fixDef,shapeSize,"img/brownDegrad.jpg");
	
	figure.setBodyDef(ground);
	return figure;
}

listener.PostSolve = function(contact, impulse) {
    if (isThereCollisionWithItem(contact,"ground") || isThereCollisionWithItem(contact, "limit")){
		if(!isThereCollisionWithItem(contact, "basic")){
			if(isGameWined || isGameOver) return;
			clearInterval(countLevelSeconds);
			isGameOver = true;
			createLoseDialog();
			
		}
    }
}

function isThereCollisionWithItem(figure, userData){
	 if (figure.GetFixtureA().GetBody().GetUserData() == userData || figure.GetFixtureB().GetBody().GetUserData() == userData){	
        return true;
    }
	return false;
}

function paintFigureToStack(){

	if(arrayShapes == null || mousePos == null) return;
	if(arrayShapes[posShapeToShow] != null){
		var shapeSize = (arrayShapes[posShapeToShow].size.x * 100 / canvas.clientWidth);
		var limitPoints = calculatePoints(limitShapeListPercent-shapeSize,0);
		if(mousePos.x > limitPoints.x) return;
	}	
	if(mouseJoinedBody != null){
		world.DestroyBody(mouseJoinedBody);
	}
	repaintActualShape(mousePos.x,mousePos.y,"moveItem");	
}

debug.onmousemove = function(evt) {
	mousePos = getMousePos(canvas, evt);
	paintFigureToStack();	
}

function updateCanvas(){

	if(stage == null || world == null) return;
	stage.update();
	world.DrawDebugData();
	world.Step(1/60, 10, 10);
	world.ClearForces();
	
	if(canvas.clientWidth != actualWidht){
		repaintAll();
	}
	forceUpdateCanvas();
}

function tick(){
	
	updateCanvas();
}